/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
	"time"
)

// checks if the Friend type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Friend{}

// Friend User invited via referral link
type Friend struct {
	Id string `json:"id"`
	ViralLoopId string `json:"viral_loop_id"`
	ReferralId string `json:"referral_id"`
	ContactId string `json:"contact_id"`
	ConversationId string `json:"conversation_id"`
	ChannelId string `json:"channel_id"`
	Rewards []Reward `json:"rewards,omitempty"`
	Status string `json:"status"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	Attributes *map[string]string `json:"attributes,omitempty"`
	Name string `json:"name"`
	TransactionId string `json:"transaction_id"`
	OrganizationId string `json:"organization_id"`
	GatewayMessengerId string `json:"gateway_messenger_id"`
	Email *string `json:"email,omitempty"`
	ReferralActivityId string `json:"referral_activity_id"`
	MessengerId string `json:"messenger_id"`
}

// NewFriend instantiates a new Friend object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFriend(id string, viralLoopId string, referralId string, contactId string, conversationId string, channelId string, status string, createdAt time.Time, updatedAt time.Time, name string, transactionId string, organizationId string, gatewayMessengerId string, referralActivityId string, messengerId string) *Friend {
	this := Friend{}
	this.Id = id
	this.ViralLoopId = viralLoopId
	this.ReferralId = referralId
	this.ContactId = contactId
	this.ConversationId = conversationId
	this.ChannelId = channelId
	this.Status = status
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.Name = name
	this.TransactionId = transactionId
	this.OrganizationId = organizationId
	this.GatewayMessengerId = gatewayMessengerId
	this.ReferralActivityId = referralActivityId
	this.MessengerId = messengerId
	return &this
}

// NewFriendWithDefaults instantiates a new Friend object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFriendWithDefaults() *Friend {
	this := Friend{}
	return &this
}

// GetId returns the Id field value
func (o *Friend) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Friend) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Friend) SetId(v string) {
	o.Id = v
}

// GetViralLoopId returns the ViralLoopId field value
func (o *Friend) GetViralLoopId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ViralLoopId
}

// GetViralLoopIdOk returns a tuple with the ViralLoopId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetViralLoopIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ViralLoopId, true
}

// SetViralLoopId sets field value
func (o *Friend) SetViralLoopId(v string) {
	o.ViralLoopId = v
}

// GetReferralId returns the ReferralId field value
func (o *Friend) GetReferralId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReferralId
}

// GetReferralIdOk returns a tuple with the ReferralId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetReferralIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReferralId, true
}

// SetReferralId sets field value
func (o *Friend) SetReferralId(v string) {
	o.ReferralId = v
}

// GetContactId returns the ContactId field value
func (o *Friend) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *Friend) SetContactId(v string) {
	o.ContactId = v
}

// GetConversationId returns the ConversationId field value
func (o *Friend) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *Friend) SetConversationId(v string) {
	o.ConversationId = v
}

// GetChannelId returns the ChannelId field value
func (o *Friend) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *Friend) SetChannelId(v string) {
	o.ChannelId = v
}

// GetRewards returns the Rewards field value if set, zero value otherwise.
func (o *Friend) GetRewards() []Reward {
	if o == nil || IsNil(o.Rewards) {
		var ret []Reward
		return ret
	}
	return o.Rewards
}

// GetRewardsOk returns a tuple with the Rewards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Friend) GetRewardsOk() ([]Reward, bool) {
	if o == nil || IsNil(o.Rewards) {
		return nil, false
	}
	return o.Rewards, true
}

// HasRewards returns a boolean if a field has been set.
func (o *Friend) HasRewards() bool {
	if o != nil && !IsNil(o.Rewards) {
		return true
	}

	return false
}

// SetRewards gets a reference to the given []Reward and assigns it to the Rewards field.
func (o *Friend) SetRewards(v []Reward) {
	o.Rewards = v
}

// GetStatus returns the Status field value
func (o *Friend) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *Friend) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *Friend) SetStatus(v string) {
	o.Status = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Friend) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Friend) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Friend) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Friend) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Friend) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Friend) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Friend) GetAttributes() map[string]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Friend) GetAttributesOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Friend) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]string and assigns it to the Attributes field.
func (o *Friend) SetAttributes(v map[string]string) {
	o.Attributes = &v
}

// GetName returns the Name field value
func (o *Friend) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Friend) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Friend) SetName(v string) {
	o.Name = v
}

// GetTransactionId returns the TransactionId field value
func (o *Friend) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *Friend) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Friend) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Friend) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetGatewayMessengerId returns the GatewayMessengerId field value
func (o *Friend) GetGatewayMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayMessengerId
}

// GetGatewayMessengerIdOk returns a tuple with the GatewayMessengerId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetGatewayMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayMessengerId, true
}

// SetGatewayMessengerId sets field value
func (o *Friend) SetGatewayMessengerId(v string) {
	o.GatewayMessengerId = v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *Friend) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Friend) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *Friend) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *Friend) SetEmail(v string) {
	o.Email = &v
}

// GetReferralActivityId returns the ReferralActivityId field value
func (o *Friend) GetReferralActivityId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReferralActivityId
}

// GetReferralActivityIdOk returns a tuple with the ReferralActivityId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetReferralActivityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReferralActivityId, true
}

// SetReferralActivityId sets field value
func (o *Friend) SetReferralActivityId(v string) {
	o.ReferralActivityId = v
}

// GetMessengerId returns the MessengerId field value
func (o *Friend) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *Friend) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *Friend) SetMessengerId(v string) {
	o.MessengerId = v
}

func (o Friend) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Friend) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["viral_loop_id"] = o.ViralLoopId
	toSerialize["referral_id"] = o.ReferralId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["channel_id"] = o.ChannelId
	if !IsNil(o.Rewards) {
		toSerialize["rewards"] = o.Rewards
	}
	toSerialize["status"] = o.Status
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["name"] = o.Name
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["gateway_messenger_id"] = o.GatewayMessengerId
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	toSerialize["referral_activity_id"] = o.ReferralActivityId
	toSerialize["messenger_id"] = o.MessengerId
	return toSerialize, nil
}

type NullableFriend struct {
	value *Friend
	isSet bool
}

func (v NullableFriend) Get() *Friend {
	return v.value
}

func (v *NullableFriend) Set(val *Friend) {
	v.value = val
	v.isSet = true
}

func (v NullableFriend) IsSet() bool {
	return v.isSet
}

func (v *NullableFriend) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFriend(val *Friend) *NullableFriend {
	return &NullableFriend{value: val, isSet: true}
}

func (v NullableFriend) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFriend) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


